diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc	2023-07-05 14:23:47.869427400 -0700
@@ -39,7 +39,8 @@
 #include <ns3/uinteger.h>
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[address " << m_shortAddress << "] ";
+#define NS_LOG_APPEND_CONTEXT                                                                      \
+    std::clog << "[address " << m_shortAddress << " | " << m_selfExt << "] ";
 
 namespace ns3
 {
@@ -188,6 +189,7 @@
     m_macSIFSPeriod = 12;
 
     m_panCoor = false;
+    m_coor = false;
     m_macBeaconOrder = 15;
     m_macSuperframeOrder = 15;
     m_macTransactionPersistenceTime = 500; // 0x01F5
@@ -276,7 +278,15 @@
     m_mlmeAssociateConfirmCallback = MakeNullCallback<void, MlmeAssociateConfirmParams>();
     m_mlmeAssociateIndicationCallback = MakeNullCallback<void, MlmeAssociateIndicationParams>();
     m_mlmeCommStatusIndicationCallback = MakeNullCallback<void, MlmeCommStatusIndicationParams>();
+    m_mlmeOrphanIndicationCallback = MakeNullCallback<void, MlmeOrphanIndicationParams>();
 
+    m_panDescriptorList.clear();
+    m_energyDetectList.clear();
+    m_unscannedChannels.clear();
+
+    m_scanEvent.Cancel();
+    m_scanEnergyEvent.Cancel();
+    m_scanOrphanEvent.Cancel();
     m_beaconEvent.Cancel();
 
     Object::DoDispose();
@@ -489,13 +499,12 @@
         // A DEVICE must be tracking beacons (MLME-SYNC.request is running) before attempting
         // request data from the coordinator.
 
-        // TODO: Check if the current device is coordinator (not just pan coordinator)
         //  Indirect Transmission can only be done by PAN coordinator or coordinators.
-        NS_ASSERT(m_panCoor);
+        NS_ASSERT(m_coor);
         p->AddHeader(macHdr);
 
         LrWpanMacTrailer macTrailer;
-        // Calculate FCS if the global attribute ChecksumEnable is set.
+        // Calculate FCS if the global attribute ChecksumEnabled is set.
         if (Node::ChecksumEnabled())
         {
             macTrailer.EnableFcs(true);
@@ -520,7 +529,7 @@
         p->AddHeader(macHdr);
 
         LrWpanMacTrailer macTrailer;
-        // Calculate FCS if the global attribute ChecksumEnable is set.
+        // Calculate FCS if the global attribute ChecksumEnabled is set.
         if (Node::ChecksumEnabled())
         {
             macTrailer.EnableFcs(true);
@@ -570,9 +579,9 @@
     m_pendPrimitive = MLME_START_REQ;
     m_startParams = params;
 
-    LrWpanPhyPibAttributes pibAttr;
-    pibAttr.phyCurrentPage = m_startParams.m_logChPage;
-    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, &pibAttr);
+    Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+    pibAttr->phyCurrentPage = m_startParams.m_logChPage;
+    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, pibAttr);
 }
 
 void
@@ -584,7 +593,7 @@
     confirmParams.m_scanType = params.m_scanType;
     confirmParams.m_chPage = params.m_chPage;
 
-    if (m_scanEvent.IsRunning() || m_scanEnergyEvent.IsRunning())
+    if ((m_scanEvent.IsRunning() || m_scanEnergyEvent.IsRunning()) || m_scanOrphanEvent.IsRunning())
     {
         if (!m_mlmeScanConfirmCallback.IsNull())
         {
@@ -595,7 +604,7 @@
         return;
     }
 
-    if (params.m_scanDuration > 14 || params.m_scanType > MLMESCAN_PASSIVE)
+    if (params.m_scanDuration > 14 || params.m_scanType > MLMESCAN_ORPHAN)
     {
         if (!m_mlmeScanConfirmCallback.IsNull())
         {
@@ -611,6 +620,7 @@
 
     m_panDescriptorList.clear();
     m_energyDetectList.clear();
+    m_unscannedChannels.clear();
 
     // TODO: stop beacon transmission
 
@@ -629,9 +639,9 @@
     m_scanParams = params;
     m_pendPrimitive = MLME_SCAN_REQ;
 
-    LrWpanPhyPibAttributes pibAttr;
-    pibAttr.phyCurrentPage = params.m_chPage;
-    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, &pibAttr);
+    Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+    pibAttr->phyCurrentPage = params.m_chPage;
+    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, pibAttr);
 }
 
 void
@@ -683,9 +693,9 @@
     }
     else
     {
-        LrWpanPhyPibAttributes pibAttr;
-        pibAttr.phyCurrentPage = params.m_chPage;
-        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, &pibAttr);
+        Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+        pibAttr->phyCurrentPage = params.m_chPage;
+        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentPage, pibAttr);
     }
 }
 
@@ -758,7 +768,7 @@
     commandPacket->AddHeader(macPayload);
     commandPacket->AddHeader(macHdr);
 
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -772,6 +782,66 @@
 }
 
 void
+LrWpanMac::MlmeOrphanResponse(MlmeOrphanResponseParams params)
+{
+    NS_LOG_FUNCTION(this);
+    // Mac header Coordinator realigment Command
+    // See 802.15.4-2011 (Section 6.2.7.2)
+    LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_COMMAND, m_macDsn.GetValue());
+    m_macDsn++;
+    LrWpanMacTrailer macTrailer;
+    Ptr<Packet> commandPacket = Create<Packet>();
+    macHdr.SetPanIdComp();
+    macHdr.SetDstAddrMode(LrWpanMacHeader::EXTADDR);
+    macHdr.SetDstAddrFields(0xffff, params.m_orphanAddr);
+
+    macHdr.SetSrcAddrMode(LrWpanMacHeader::EXTADDR);
+    macHdr.SetSrcAddrFields(m_macPanId, GetExtendedAddress());
+    macHdr.SetSrcAddrFields(m_macPanId, Mac16Address("FF:FF"));
+
+    macHdr.SetFrameVer(0x01);
+    macHdr.SetSecDisable();
+    macHdr.SetAckReq();
+
+    CommandPayloadHeader macPayload(CommandPayloadHeader::COOR_REALIGN);
+    macPayload.SetPanId(m_macPanId);
+    macPayload.SetCoordShortAddr(GetShortAddress());
+    macPayload.SetChannel(m_phy->GetCurrentChannelNum());
+    macPayload.SetPage(m_phy->GetCurrentPage());
+
+    if (params.m_assocMember)
+    {
+        // The orphan device was associated with the coordinator
+
+        // Either FF:FE for extended address mode
+        // or the short address assigned by the coord.
+        macPayload.SetShortAddr(params.m_shortAddr);
+    }
+    else
+    {
+        // The orphan device was NOT associated with the coordinator
+        macPayload.SetShortAddr(Mac16Address("FF:FF"));
+    }
+
+    commandPacket->AddHeader(macPayload);
+    commandPacket->AddHeader(macHdr);
+
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
+    if (Node::ChecksumEnabled())
+    {
+        macTrailer.EnableFcs(true);
+        macTrailer.SetFcs(commandPacket);
+    }
+
+    commandPacket->AddTrailer(macTrailer);
+
+    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    txQElement->txQPkt = commandPacket;
+    EnqueueTxQElement(txQElement);
+    CheckQueue();
+}
+
+void
 LrWpanMac::MlmeSyncRequest(MlmeSyncRequestParams params)
 {
     NS_LOG_FUNCTION(this);
@@ -779,9 +849,9 @@
 
     uint64_t symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
     // change phy current logical channel
-    LrWpanPhyPibAttributes pibAttr;
-    pibAttr.phyCurrentChannel = params.m_logCh;
-    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, &pibAttr);
+    Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+    pibAttr->phyCurrentChannel = params.m_logCh;
+    m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, pibAttr);
 
     // Enable Phy receiver
     m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
@@ -830,16 +900,17 @@
 LrWpanMac::MlmeSetRequest(LrWpanMacPibAttributeIdentifier id, Ptr<LrWpanMacPibAttributes> attribute)
 {
     MlmeSetConfirmParams confirmParams;
+    confirmParams.m_status = MLMESET_SUCCESS;
+
     switch (id)
     {
     case macBeaconPayload:
-        if (attribute->macBeaconPayload->GetSize() > lrwpan::aMaxBeaconPayloadLenght)
+        if (attribute->macBeaconPayload->GetSize() > lrwpan::aMaxBeaconPayloadLength)
         {
             confirmParams.m_status = MLMESET_INVALID_PARAMETER;
         }
         else
         {
-            confirmParams.m_status = MLMESET_SUCCESS;
             m_macBeaconPayload = attribute->macBeaconPayload;
             m_macBeaconPayloadLength = attribute->macBeaconPayload->GetSize();
         }
@@ -847,6 +918,15 @@
     case macBeaconPayloadLength:
         confirmParams.m_status = MLMESET_INVALID_PARAMETER;
         break;
+    case macShortAddress:
+        m_shortAddress = attribute->macShortAddress;
+        break;
+    case macExtendedAddress:
+        confirmParams.m_status = MLMESET_READ_ONLY;
+        break;
+    case macPanId:
+        m_macPanId = macPanId;
+        break;
     default:
         // TODO: Add support for setting other attributes
         confirmParams.m_status = MLMESET_UNSUPPORTED_ATTRIBUTE;
@@ -861,6 +941,40 @@
 }
 
 void
+LrWpanMac::MlmeGetRequest(LrWpanMacPibAttributeIdentifier id)
+{
+    LrWpanMlmeGetConfirmStatus status = MLMEGET_SUCCESS;
+    Ptr<LrWpanMacPibAttributes> attributes = Create<LrWpanMacPibAttributes>();
+
+    switch (id)
+    {
+    case macBeaconPayload:
+        attributes->macBeaconPayload = m_macBeaconPayload;
+        break;
+    case macBeaconPayloadLength:
+        attributes->macBeaconPayloadLength = m_macBeaconPayloadLength;
+        break;
+    case macShortAddress:
+        attributes->macShortAddress = m_shortAddress;
+        break;
+    case macExtendedAddress:
+        attributes->macExtendedAddress = m_selfExt;
+        break;
+    case macPanId:
+        attributes->macPanId = m_macPanId;
+        break;
+    default:
+        status = MLMEGET_UNSUPPORTED_ATTRIBUTE;
+        break;
+    }
+
+    if (!m_mlmeGetConfirmCallback.IsNull())
+    {
+        m_mlmeGetConfirmCallback(status, id, attributes);
+    }
+}
+
+void
 LrWpanMac::SendOneBeacon()
 {
     NS_LOG_FUNCTION(this);
@@ -906,7 +1020,7 @@
     beaconPacket->AddHeader(macPayload);
     beaconPacket->AddHeader(macHdr);
 
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -944,8 +1058,8 @@
     macHdr.SetDstAddrMode(LrWpanMacHeader::SHORTADDR);
     macHdr.SetSrcAddrMode(LrWpanMacHeader::NOADDR);
 
-    macHdr.SetDstAddrFields(0xFFFF,
-                            Mac16Address("FF:FF")); // Not associated PAN, broadcast dst address
+    // Not associated PAN, broadcast dst address
+    macHdr.SetDstAddrFields(0xFFFF, Mac16Address("FF:FF"));
 
     macHdr.SetSecDisable();
     macHdr.SetNoAckReq();
@@ -956,7 +1070,48 @@
     commandPacket->AddHeader(macPayload);
     commandPacket->AddHeader(macHdr);
 
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
+    if (Node::ChecksumEnabled())
+    {
+        macTrailer.EnableFcs(true);
+        macTrailer.SetFcs(commandPacket);
+    }
+
+    commandPacket->AddTrailer(macTrailer);
+
+    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    txQElement->txQPkt = commandPacket;
+    EnqueueTxQElement(txQElement);
+    CheckQueue();
+}
+
+void
+LrWpanMac::SendOrphanNotificationCommand()
+{
+    LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_COMMAND, m_macDsn.GetValue());
+    m_macDsn++;
+    LrWpanMacTrailer macTrailer;
+    Ptr<Packet> commandPacket = Create<Packet>();
+
+    // See IEEE 802.15.4-2011 (5.3.6)
+    macHdr.SetPanIdComp();
+
+    macHdr.SetSrcAddrMode(LrWpanMacHeader::EXTADDR);
+    macHdr.SetSrcAddrFields(0xFFFF, GetExtendedAddress());
+
+    macHdr.SetDstAddrMode(LrWpanMacHeader::SHORTADDR);
+    macHdr.SetDstAddrFields(0xFFFF, Mac16Address("FF:FF"));
+
+    macHdr.SetSecDisable();
+    macHdr.SetNoAckReq();
+
+    CommandPayloadHeader macPayload;
+    macPayload.SetCommandFrameType(CommandPayloadHeader::ORPHAN_NOTIF);
+
+    commandPacket->AddHeader(macPayload);
+    commandPacket->AddHeader(macHdr);
+
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -1005,7 +1160,7 @@
     commandPacket->AddHeader(macPayload);
     commandPacket->AddHeader(macHdr);
 
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -1063,7 +1218,7 @@
     commandPacket->AddHeader(macPayload);
     commandPacket->AddHeader(macHdr);
 
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -1139,9 +1294,11 @@
         if (m_startParams.m_panCoor)
         {
             m_panCoor = true;
-            m_macPanId = m_startParams.m_PanId;
         }
 
+        m_coor = true;
+        m_macPanId = m_startParams.m_PanId;
+
         NS_ASSERT(m_startParams.m_PanId != 0xffff);
 
         m_macBeaconOrder = m_startParams.m_bcnOrd;
@@ -1160,6 +1317,7 @@
             m_incCfpEvent.Cancel();
             m_trackingEvent.Cancel();
             m_scanEvent.Cancel();
+            m_scanOrphanEvent.Cancel();
             m_scanEnergyEvent.Cancel();
 
             m_csmaCa->SetUnSlottedCsmaCa();
@@ -1221,36 +1379,74 @@
     if (channelFound)
     {
         // Switch to the next channel in the list and restart scan
-        LrWpanPhyPibAttributes pibAttr;
-        pibAttr.phyCurrentChannel = m_channelScanIndex;
-        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, &pibAttr);
+        Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+        pibAttr->phyCurrentChannel = m_channelScanIndex;
+        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, pibAttr);
     }
     else
     {
-        // All scans on the channel list completed
-        // Return to the MAC values previous to start of the first scan.
+        // All channels in the list scan completed.
+        // Return variables to the values before the scan and return the status to the next layer.
         m_macPanId = m_macPanIdScan;
         m_macPanIdScan = 0;
 
         // TODO: restart beacon transmissions that were active before the beginning of the scan
         // (i.e when a coordinator perform a scan and it was already transmitting beacons)
-
-        // All channels scanned, report success
         MlmeScanConfirmParams confirmParams;
-        confirmParams.m_status = MLMESCAN_SUCCESS;
         confirmParams.m_chPage = m_scanParams.m_chPage;
         confirmParams.m_scanType = m_scanParams.m_scanType;
         confirmParams.m_energyDetList = {};
-        confirmParams.m_panDescList = m_panDescriptorList;
+        confirmParams.m_unscannedCh = m_unscannedChannels;
+        confirmParams.m_resultListSize = m_panDescriptorList.size();
 
-        if (!m_mlmeScanConfirmCallback.IsNull())
+        // See IEEE 802.15.4-2011, Table 31 (panDescriptorList value on macAutoRequest)
+        // and Section 6.2.10.2
+        switch (confirmParams.m_scanType)
         {
-            m_mlmeScanConfirmCallback(confirmParams);
+        case MLMESCAN_PASSIVE:
+            if (m_macAutoRequest)
+            {
+                confirmParams.m_panDescList = m_panDescriptorList;
+            }
+            confirmParams.m_status = MLMESCAN_SUCCESS;
+            break;
+        case MLMESCAN_ACTIVE:
+            if (m_panDescriptorList.empty())
+            {
+                confirmParams.m_status = MLMESCAN_NO_BEACON;
+            }
+            else
+            {
+                if (m_macAutoRequest)
+                {
+                    confirmParams.m_panDescList = m_panDescriptorList;
+                }
+                confirmParams.m_status = MLMESCAN_SUCCESS;
+            }
+            break;
+        case MLMESCAN_ORPHAN:
+            confirmParams.m_panDescList = {};
+            confirmParams.m_status = MLMESCAN_NO_BEACON;
+            confirmParams.m_resultListSize = 0;
+            // The device lost track of the coordinator and was unable
+            // to locate it, disassociate from the network.
+            m_macPanId = 0xffff;
+            m_shortAddress = Mac16Address("FF:FF");
+            m_macCoordShortAddress = Mac16Address("ff:ff");
+            m_macCoordExtendedAddress = Mac64Address("ff:ff:ff:ff:ff:ff:ff:ed");
+            break;
+        default:
+            NS_LOG_ERROR(this << " Invalid scan type");
         }
 
         m_pendPrimitive = MLME_NONE;
         m_channelScanIndex = 0;
         m_scanParams = {};
+
+        if (!m_mlmeScanConfirmCallback.IsNull())
+        {
+            m_mlmeScanConfirmCallback(confirmParams);
+        }
     }
 }
 
@@ -1259,7 +1455,7 @@
 {
     NS_LOG_FUNCTION(this);
     // Add the results of channel energy scan to the detectList
-    m_energyDetectList.push_back(m_maxEnergyLevel);
+    m_energyDetectList.emplace_back(m_maxEnergyLevel);
     m_maxEnergyLevel = 0;
 
     m_channelScanIndex++;
@@ -1278,9 +1474,9 @@
     if (channelFound)
     {
         // switch to the next channel in the list and restart scan
-        LrWpanPhyPibAttributes pibAttr;
-        pibAttr.phyCurrentChannel = m_channelScanIndex;
-        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, &pibAttr);
+        Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+        pibAttr->phyCurrentChannel = m_channelScanIndex;
+        m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel, pibAttr);
     }
     else
     {
@@ -1293,18 +1489,21 @@
         // (i.e when a coordinator perform a scan and it was already transmitting beacons)
 
         // All channels scanned, report success
+        MlmeScanConfirmParams confirmParams;
+        confirmParams.m_status = MLMESCAN_SUCCESS;
+        confirmParams.m_chPage = m_phy->GetCurrentPage();
+        confirmParams.m_scanType = m_scanParams.m_scanType;
+        confirmParams.m_energyDetList = m_energyDetectList;
+        confirmParams.m_resultListSize = m_energyDetectList.size();
+
+        m_pendPrimitive = MLME_NONE;
+        m_channelScanIndex = 0;
+        m_scanParams = {};
+
         if (!m_mlmeScanConfirmCallback.IsNull())
         {
-            MlmeScanConfirmParams confirmParams;
-            confirmParams.m_status = MLMESCAN_SUCCESS;
-            confirmParams.m_chPage = m_phy->GetCurrentPage();
-            confirmParams.m_scanType = m_scanParams.m_scanType;
-            confirmParams.m_energyDetList = m_energyDetectList;
             m_mlmeScanConfirmCallback(confirmParams);
         }
-        m_pendPrimitive = MLME_NONE;
-        m_channelScanIndex = 0;
-        m_scanParams = {};
     }
 }
 
@@ -1495,9 +1694,7 @@
     // Pull a packet from the queue and start sending if we are not already sending.
     if (m_lrWpanMacState == MAC_IDLE && !m_txQueue.empty() && !m_setMacState.IsRunning())
     {
-        // TODO: this should check if the node is a coordinator and using the outcoming superframe
-        // not just the PAN coordinator
-        if (m_csmaCa->IsUnSlottedCsmaCa() || (m_outSuperframeStatus == CAP && m_panCoor) ||
+        if (m_csmaCa->IsUnSlottedCsmaCa() || (m_outSuperframeStatus == CAP && m_coor) ||
             m_incSuperframeStatus == CAP)
         {
             // check MAC is not in a IFS
@@ -1597,6 +1794,12 @@
 }
 
 void
+LrWpanMac::SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c)
+{
+    m_mlmeOrphanIndicationCallback = c;
+}
+
+void
 LrWpanMac::SetMcpsDataConfirmCallback(McpsDataConfirmCallback c)
 {
     m_mcpsDataConfirmCallback = c;
@@ -1645,6 +1848,12 @@
 }
 
 void
+LrWpanMac::SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c)
+{
+    m_mlmeGetConfirmCallback = c;
+}
+
+void
 LrWpanMac::PdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi)
 {
     NS_ASSERT(m_lrWpanMacState == MAC_IDLE || m_lrWpanMacState == MAC_ACK_PENDING ||
@@ -1754,11 +1963,11 @@
 
             if (acceptFrame && (receivedMacHdr.GetDstAddrMode() > 1))
             {
-                // Accept frame if:
+                // Accept frame if one of the following is true:
 
                 // 1) Have the same macPanId
-                // 2) Or is Message to all PANs
-                // 3) Or Is a beacon and the macPanId is not present (bootstrap)
+                // 2) Is Message to all PANs
+                // 3) Is a beacon or command frame and the macPanId is not present (bootstrap)
                 acceptFrame = ((receivedMacHdr.GetDstPanId() == m_macPanId ||
                                 receivedMacHdr.GetDstPanId() == 0xffff) ||
                                (m_macPanId == 0xffff && receivedMacHdr.IsBeacon())) ||
@@ -1767,10 +1976,17 @@
 
             if (acceptFrame && (receivedMacHdr.GetShortDstAddr() == Mac16Address("FF:FF")))
             {
-                // A broadcast message (e.g. beacons) should not be received by the device who
-                // issues it.
-                acceptFrame = (receivedMacHdr.GetShortSrcAddr() != GetShortAddress());
                 // TODO: shouldn't this be filtered by the PHY?
+                // A broadcast message (e.g. beacons, orphan notifications) should not be received
+                // by the device who issues it.
+                if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR)
+                {
+                    acceptFrame = (receivedMacHdr.GetExtSrcAddr() != GetExtendedAddress());
+                }
+                else
+                {
+                    acceptFrame = (receivedMacHdr.GetShortSrcAddr() != GetShortAddress());
+                }
             }
 
             if (acceptFrame && (receivedMacHdr.GetDstAddrMode() == SHORT_ADDR))
@@ -1783,16 +1999,9 @@
                 else if (receivedMacHdr.GetShortDstAddr().IsBroadcast() ||
                          receivedMacHdr.GetShortDstAddr().IsMulticast())
                 {
-                    // broadcast or multicast
-                    if (receivedMacHdr.IsAckReq())
-                    {
-                        // discard broadcast/multicast with the ACK bit set
-                        acceptFrame = false;
-                    }
-                    else
-                    {
-                        acceptFrame = true;
-                    }
+                    // Broadcast or multicast.
+                    // Discard broadcast/multicast with the ACK bit set.
+                    acceptFrame = !receivedMacHdr.IsAckReq();
                 }
                 else
                 {
@@ -1805,15 +2014,23 @@
                 acceptFrame = (receivedMacHdr.GetExtDstAddr() == m_selfExt);
             }
 
-            // When PASSIVE or ACTIVE scan is running, reject any frames other than BEACON frames
-            if (acceptFrame && (!receivedMacHdr.IsBeacon() && m_scanEvent.IsRunning()))
+            if (acceptFrame && m_scanEvent.IsRunning())
             {
-                acceptFrame = false;
+                if (!receivedMacHdr.IsBeacon())
+                {
+                    acceptFrame = false;
+                }
             }
-
-            // Energy Scan is running, reject any frames
-            if (m_scanEnergyEvent.IsRunning())
+            else if (acceptFrame && m_scanOrphanEvent.IsRunning())
+            {
+                if (!receivedMacHdr.IsCommand())
+                {
+                    acceptFrame = false;
+                }
+            }
+            else if (m_scanEnergyEvent.IsRunning())
             {
+                // Reject any frames if energy scan is running
                 acceptFrame = false;
             }
 
@@ -1828,7 +2045,7 @@
 
                 if (receivedMacPayload.GetCommandFrameType() ==
                         CommandPayloadHeader::ASSOCIATION_REQ &&
-                    !(m_macAssociationPermit == true && m_panCoor == true))
+                    !(m_macAssociationPermit && m_coor))
                 {
                     acceptFrame = false;
                 }
@@ -2073,7 +2290,7 @@
 
                             if (!descriptorExists)
                             {
-                                m_panDescriptorList.push_back(panDescriptor);
+                                m_panDescriptorList.emplace_back(panDescriptor);
                             }
                             return;
                         }
@@ -2130,15 +2347,15 @@
                 }
                 else if (receivedMacHdr.IsCommand())
                 {
-                    // Handle the reception of frame commands that do not require ACK (i.e. Beacon
-                    // Request Command)
+                    // Handle the reception of frame commands that do not require ACK
+                    // (i.e. Beacon Request, Orphan notification, Coordinator Realigment)
                     CommandPayloadHeader receivedMacPayload;
                     p->PeekHeader(receivedMacPayload);
-                    if (receivedMacPayload.GetCommandFrameType() ==
-                        CommandPayloadHeader::BEACON_REQ)
+
+                    switch (receivedMacPayload.GetCommandFrameType())
                     {
-                        // TODO: check that node is any coordinator not just pan coordinator
-                        if (m_csmaCa->IsUnSlottedCsmaCa() && m_panCoor)
+                    case CommandPayloadHeader::BEACON_REQ:
+                        if (m_csmaCa->IsUnSlottedCsmaCa() && m_coor)
                         {
                             SendOneBeacon();
                         }
@@ -2146,6 +2363,51 @@
                         {
                             m_macRxDropTrace(originalPkt);
                         }
+                        break;
+                    case CommandPayloadHeader::ORPHAN_NOTIF:
+                        if (!m_mlmeOrphanIndicationCallback.IsNull())
+                        {
+                            if (m_coor)
+                            {
+                                MlmeOrphanIndicationParams orphanParams;
+                                orphanParams.m_orphanAddr = receivedMacHdr.GetExtSrcAddr();
+                                m_mlmeOrphanIndicationCallback(orphanParams);
+                            }
+                        }
+                        break;
+                    case CommandPayloadHeader::COOR_REALIGN:
+                        if (m_scanOrphanEvent.IsRunning())
+                        {
+                            // Coordinator located, no need to keep scanning other channels
+                            m_scanOrphanEvent.Cancel();
+
+                            m_macPanIdScan = 0;
+                            m_pendPrimitive = MLME_NONE;
+                            m_channelScanIndex = 0;
+
+                            // Update the device information with the received information
+                            // from the Coordinator Realigment command.
+                            m_macPanId = receivedMacPayload.GetPanId();
+                            m_shortAddress = receivedMacPayload.GetShortAddr();
+                            m_macCoordExtendedAddress = receivedMacHdr.GetExtSrcAddr();
+                            m_macCoordShortAddress = receivedMacPayload.GetCoordShortAddr();
+
+                            if (!m_mlmeScanConfirmCallback.IsNull())
+                            {
+                                MlmeScanConfirmParams confirmParams;
+                                confirmParams.m_scanType = m_scanParams.m_scanType;
+                                confirmParams.m_chPage = m_scanParams.m_chPage;
+                                confirmParams.m_status = MLMESCAN_SUCCESS;
+                                m_mlmeScanConfirmCallback(confirmParams);
+                            }
+                            m_scanParams = {};
+                        }
+                        // TODO: handle Coordinator realignment when not
+                        //       used during an orphan scan.
+                        break;
+                    default:
+                        m_macRxDropTrace(originalPkt);
+                        break;
                     }
                 }
                 else if (receivedMacHdr.IsData() && !m_mcpsDataIndicationCallback.IsNull())
@@ -2245,6 +2507,24 @@
                                 break;
                             }
 
+                            case CommandPayloadHeader::COOR_REALIGN: {
+                                // ACK of coordinator realigment commands is not specified in the
+                                // standard, in here, we assume they are required as in other
+                                // commands.
+                                if (!m_mlmeCommStatusIndicationCallback.IsNull())
+                                {
+                                    MlmeCommStatusIndicationParams commStatusParams;
+                                    commStatusParams.m_panId = m_macPanId;
+                                    commStatusParams.m_srcAddrMode = LrWpanMacHeader::EXTADDR;
+                                    commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
+                                    commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
+                                    commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
+                                    commStatusParams.m_status =
+                                        LrWpanMlmeCommStatus::MLMECOMMSTATUS_SUCCESS;
+                                    m_mlmeCommStatusIndicationCallback(commStatusParams);
+                                }
+                            }
+
                             default: {
                                 // TODO: add response to other request commands (e.g. Orphan)
                                 break;
@@ -2316,7 +2596,7 @@
     LrWpanMacTrailer macTrailer;
     Ptr<Packet> ackPacket = Create<Packet>(0);
     ackPacket->AddHeader(macHdr);
-    // Calculate FCS if the global attribute ChecksumEnable is set.
+    // Calculate FCS if the global attribute ChecksumEnabled is set.
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
